//ps2pad_lib
//Ver0.7
//`錾
#define READ_DATA					2
#define READ_DATA_AND_VIBRATE_EX	3
#define CONFIG_MODE_ENTER			4
#define PRES_TRANS_START			5
#define CONFIG_MODE_EXIT			6
#define QUERY_MODEL_AND_MODE		7
#define SET_MODE_AND_LOCK			8
#define PRESSURE_ENABLE				9
#define QUERY_DS2_ANALOG_MODE		10
#define VIBRATION_ENABLE			11
//Cxg̒`
#define PAD_EVENT_LIB_INITED			0//Cxg
#define PAD_EVENT_CONNECTION_ERROR		1
#define PAD_EVENT_RECEIVED_PAD_DATA		2
#define PS_PAD_LEFT						!bit_test(pad_data[3],7)
#define PS_PAD_DOWN						!bit_test(pad_data[3],6)
#define PS_PAD_RIGHT					!bit_test(pad_data[3],5)
#define PS_PAD_UP						!bit_test(pad_data[3],4)
#define PS_PAD_START					!bit_test(pad_data[3],3)
#define PS_PAD_R3						!bit_test(pad_data[3],2)
#define PS_PAD_L3						!bit_test(pad_data[3],1)
#define PS_PAD_SELECT					!bit_test(pad_data[3],0)
#define PS_PAD_SHIKAKU					!bit_test(pad_data[4],7)
#define PS_PAD_BATU						!bit_test(pad_data[4],6)
#define PS_PAD_MARU						!bit_test(pad_data[4],5)
#define PS_PAD_SANKAKU					!bit_test(pad_data[4],4)
#define PS_PAD_R1						!bit_test(pad_data[4],3)
#define PS_PAD_L1						!bit_test(pad_data[4],2)
#define PS_PAD_R2						!bit_test(pad_data[4],1)
#define PS_PAD_L2						!bit_test(pad_data[4],0)
#define PS_PAD_AL_RIGHT_LR_RAW_VALUE	pad_data[5]//EXeBN̍E
#define PS_PAD_AL_RIGHT_UD_RAW_VALUE	pad_data[6]//EXeBN̏㉺
#define PS_PAD_AL_LEFT_LR_RAW_VALUE		pad_data[7]//XeBN̍E
#define PS_PAD_AL_LEFT_UD_RAW_VALUE		pad_data[8]//XeBN̏㉺
#define PS_PAD_AD_RIGHT					pad_data[9]
#define PS_PAD_AD_LEFT					pad_data[10]
#define PS_PAD_AD_UP					pad_data[11]
#define PS_PAD_AD_DOWN					pad_data[12]
#define PS_PAD_AD_SANKAKU				pad_data[13]
#define PS_PAD_AD_MARU					pad_data[14]
#define PS_PAD_AD_BATU					pad_data[15]
#define PS_PAD_AD_SHIKAKU				pad_data[16]
#define PS_PAD_AD_L1					pad_data[17]
#define PS_PAD_AD_R1					pad_data[18]
#define PS_PAD_AD_L2					pad_data[19]
#define PS_PAD_AD_R2					pad_data[20]
//֐錾
void ps2pad_lib_init();//֐
void ps2pad_rx();
void ps2pad_command(int command);
int ps2pad_send_and_get_data(int send_data);
void ps2pad_event_handler(int event);//Cxgɂ΂֐ ̕Kv
int lsb_msb_swap(int data);
//ϐ錾
int pad_data[21];
int pad_state;
//R}hf[^`
const int config_mode_enter_send_data[9]		= { 0x01, 0x43, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00 };
const int config_mode_exit2_send_data[9]		= { 0x01, 0x43, 0x00, 0x00, 0x5a, 0x5a, 0x5a, 0x5a, 0x5a };
const int config_mode_exit_send_data[9]			= { 0x01, 0x43, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const int set_mode_and_lock_send_data[9]		= { 0x01, 0x44, 0x00, 0x01, 0x03, 0x00, 0x00, 0x00, 0x00 };
const int query_model_and_mode_send_data[9]		= { 0x01, 0x45, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const int vibration_enable_send_data[9]			= { 0x01, 0x4d, 0x00, 0x00, 0x01, 0xff, 0xff, 0xff, 0xff };
const int vibration_disnable_send_data[9]		= { 0x01, 0x4d, 0x00 ,0xff, 0xff, 0xff, 0xff, 0xff, 0xff };
const int query_ds2_analog_mode_data[9]			= { 0x01, 0x41, 0x00, 0x5a, 0x5a, 0x5a, 0x5a, 0x5a, 0x5a };
const int set_ds2_native_mode_data[9]			= { 0x01, 0x4f, 0x00, 0xff, 0xff, 0x03, 0x00, 0x00, 0x00 };
const int read_data_send_data[9]				= { 0x01, 0x42, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const int read_data_and_vibrate_ex_send_data[9]	= { 0x01, 0x42, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
void ps2pad_lib_init(){
	int i;
	//SPIʐM̐ݒ
	setup_timer_2(T2_DIV_BY_1,128,1);
	setup_spi(spi_master | spi_l_to_h | SPI_CLK_T2 | SPI_SAMPLE_AT_END);
	set_timer2(0);
	//PS_PAD_SEL:HIGH
	output_bit(PS_PAD_SEL_PIN, HIGH);
	//ϐ
	for(i = 0;i < 9;i++){
		pad_data[i] = 0;
	}
	pad_state = 0;
	ps2pad_event_handler(PAD_EVENT_LIB_INITED);
}
void ps2pad_rx(){
	int i;
	switch(pad_state){
		case 0://ڑ
			//fAVbN2mF
			ps2pad_command(READ_DATA);
			ps2pad_command(CONFIG_MODE_ENTER);
			ps2pad_command(SET_MODE_AND_LOCK);
			ps2pad_command(CONFIG_MODE_EXIT);
			ps2pad_command(READ_DATA);
			if( pad_data[1] == 0x73 ){
				pad_state = 1;
			}else if(pad_data[1] == 0x79){//0x79͋AĂȂnYȂ̂EEEȂAĂorz
				pad_state = 2;
			}else{
				//G[
				pad_state = 0;
				ps2pad_event_handler(PAD_EVENT_CONNECTION_ERROR);
			}
			break;
		case 1://f[^ǂݎ
			ps2pad_command(CONFIG_MODE_ENTER);
			ps2pad_command(PRESSURE_ENABLE);
			ps2pad_command(PRES_TRANS_START);
			ps2pad_command(CONFIG_MODE_EXIT);
			ps2pad_command(READ_DATA_AND_VIBRATE_EX);
			if( pad_data[1] == 0x73 ){//fAVbN2ɐ؂ւĂȂ̂ŃgC
				pad_state = 1;
			}else if( pad_data[1] == 0x79 ){
				ps2pad_event_handler(PAD_EVENT_RECEIVED_PAD_DATA);
				pad_state = 2;
			}else{
				//G[
				pad_state = 0;
				ps2pad_event_handler(PAD_EVENT_CONNECTION_ERROR);
			}
			break;
		case 2:
			ps2pad_command(READ_DATA_AND_VIBRATE_EX);
			if( pad_data[1] == 0x79 ){
				ps2pad_event_handler(PAD_EVENT_RECEIVED_PAD_DATA);
			}else{
				//G[
				pad_state = 0;
				ps2pad_event_handler(PAD_EVENT_CONNECTION_ERROR);
			}
			break;
		}
}

void ps2pad_command(int command){
	int i;
	output_bit(PS_PAD_SEL_PIN, LOW);
	switch(command){
		case READ_DATA:
			for(i = 0;i < 9;i++){
				pad_data[i] = ps2pad_send_and_get_data( read_data_send_data[ i ] );
			}
			break;
		case READ_DATA_AND_VIBRATE_EX:
			for(i = 0;i < 9;i++){
				pad_data[i] = ps2pad_send_and_get_data( read_data_and_vibrate_ex_send_data[ i ] );
			}
			for(i = 9;i < 21;i++){
				pad_data[i] = ps2pad_send_and_get_data(0);
			}
			break;
		case CONFIG_MODE_ENTER:
			for(i = 0;i < 9;i++){
				pad_data[i] = ps2pad_send_and_get_data( config_mode_enter_send_data[ i ] );
			}
			break;
		case CONFIG_MODE_EXIT:
			for(i = 0;i < 9;i++){
				pad_data[i] = ps2pad_send_and_get_data( config_mode_exit_send_data[ i ] );
			}
			break;
		case PRES_TRANS_START:
			for(i = 0;i < 9;i++){
				pad_data[i] = ps2pad_send_and_get_data( config_mode_exit2_send_data[ i ] );
			}
			break;
		case QUERY_MODEL_AND_MODE:
			for(i = 0;i < 9;i++){
				pad_data[i] = ps2pad_send_and_get_data( query_model_and_mode_send_data[ i ] );
			}
			break;
		case SET_MODE_AND_LOCK:
			for(i = 0;i < 9;i++){
				pad_data[i] = ps2pad_send_and_get_data( set_mode_and_lock_send_data[ i ] );
			}
			break;
		case PRESSURE_ENABLE:
			for(i = 0;i < 9;i++){
				pad_data[i] = ps2pad_send_and_get_data( set_ds2_native_mode_data[ i ] );
			}
			break;
		case QUERY_DS2_ANALOG_MODE:
			for(i = 0;i < 9;i++){
				pad_data[i] = ps2pad_send_and_get_data( query_ds2_analog_mode_data[ i ] );
			}
			break;
		case VIBRATION_ENABLE:
			for(i = 0;i < 9;i++){
				pad_data[i] = ps2pad_send_and_get_data( vibration_enable_send_data[ i ] );
			}
			break;


	}
	output_bit( PS_PAD_SEL_PIN , HIGH );
}
int ps2pad_send_and_get_data(int send_data){
	return lsb_msb_swap( spi_read( ( lsb_msb_swap( send_data ) ) ) );
}

int lsb_msb_swap(int data)
{
	int temp = 0;
	#asm
	BTFSC	data,7
	BSF		temp,0
	BTFSC	data,6
	BSF		temp,1
	BTFSC	data,5
	BSF		temp,2
	BTFSC	data,4
	BSF		temp,3
	BTFSC	data,3
	BSF		temp,4
	BTFSC	data,2
	BSF		temp,5
	BTFSC	data,1
	BSF		temp,6
	BTFSC	data,0
	BSF		temp,7
	#endasm
	return temp;
}
